# このスクリプトはProject directory上からsh SCRIPT/make_gid2name.shのように
# 実行することを想定している.

input_file=gencode.vM30.annotation.gtf.gz
output_file=gid2name

cd REFERENCE   # （必要なら）事前に*.gtfファイルの配置されたdirectoryに移動しておく.

zcat $input_file            | # zcatが使用できぬ場合は<b>gunzip -c</b>
grep -v '^#'                | # 冒頭のコメント行を除く処理
awk -F'\t' '$3=="gene"'     | # 3列目が<b>gene</b>であるエントリーのみ抽出
awk -F'\t' '{print $9}'     | # 9列目に遺伝子ＩＤと遺伝子名の情報があるので抽出
awk -F ';' '{print $1, $3}' | # ;区切りの1,3列目を抽出
awk '{print $2, $4}'        | # スペース区切りの2,4列目を抽出
tr -d '"'                   | # 不要な引用符を除く
tr '.' ' '                  | # 以下2行はGene IDのバージョン番号を取除くための処理
awk '{print $1, $3}'        | # 正規表現で正確にマッチさせ置換する処理の方が望ましい
sort > $output_file
