input=DEG/deseq2
output=DEG/deseq2_processed.csv
gid2name=REFERENCE/gid2name

cat $input                 |
# ヘッダーを除く
tail -n +2                 |
# 1:ID 3:logFC 7:adjusted_p_val
awk '{print $1, $3, $7}'   |
# 引用符を除く
tr -d '"'                  |
# 欠損値を含む行を除く
awk '$3!="NA"'             |
awk '$4!="NA"'             |
# 2:logFCを2:FCに変換する
awk '{print $1, 2^$2, $3}' |
# 遺伝子名情報を内部結合で追加する
join -o 1.1 2.2 1.2 1.3 - $gid2name |

  # 1番目のファイル: d2_processed 
  # 2番目のファイル: gid2name
  # 
  # 1列目を共通キーとして両者を内部結合している.
  # キー列(1列目)はあらかじめソートされている必要がある. 
  # 
  # -o 1.1 2.2 1.2 1.3 の箇所で何をどの順に出力するかを指定.
  #   1.1: ファイル1の1列目
  #   2.2: ファイル2の2列目
  #   1.2: ファイル1の2列目
  #   1.3: ファイル1の3列目

# EXCELで開きやすいようCSV形式にする
tr ' ' ',' > $output
